/*****************************************************
*  fW^ddv@PIC24FJ64GB002USBzXg[h
*  ^ubǧvR}hMŁAvʂ𑗐M
*  Mf[^tH[}bg
*	0.MESURER}h(0x02)
*	1.d(1)d(2)̋
*	2.
*	3.
*	4.f[^ĉ
*	5.f[^
*	6.f[^ŏ
*****************************************************/
/* t@C̃CN[h */
#include "USB/usb.h"
#include "USB/usb_host_android.h"
#include "Compiler.h"
#include "HardwareProfile.h"

#define MAX_ALLOWED_CURRENT     (500)    // Maximum power we can supply in mA

/* RtBM[V̐ݒ */
_CONFIG1(WINDIS_OFF & FWDTEN_OFF & ICS_PGx1 & GCP_OFF & JTAGEN_OFF) 
_CONFIG2(POSCMOD_XT & I2C1SEL_PRI & OSCIOFNC_OFF & FCKSM_CSDCMD & FNOSC_PRIPLL
		 & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
_CONFIG3(SOSCSEL_IO)

/* Xe[gϐ̐錾 */
typedef enum{
	DEVICE_NOT_CONNECTED,
	DEVICE_CONNECTED,
	RECEIVE,	
	RECEIVE_WAIT,
	SEND,
	SEND_WAIT,
}AP_STATE;
volatile AP_STATE State;
/* R}h̐錾` **/
typedef enum _AP_COMMAND{
	OKCHECK	= 0x01,
	MESURE	= 0x02,
	DISCONNECT 	= 0x7F	
}AP_COMMAND;	
volatile AP_COMMAND Command;
/* O[oϐ` */
static void* device_handle = NULL;
static BOOL device_attached = FALSE;
static BYTE read_buffer[64];
static BYTE send_buffer[64];
static BYTE count= 0;
/** AhChڑpp[^ **/
static char manufacturer[]	= "Microchip Design Lab";
static char model[] 		= "DMMBoard";
static char description[] 	= "DMM Board";
static char version[] 		= "1.0";
static char uri[] 			= "http://www.picfun.com";
static char serial[] 		= "N/A";

ANDROID_ACCESSORY_INFORMATION myDeviceInfo =
{
    manufacturer,	sizeof(manufacturer),
    model,    		sizeof(model),
    description,    sizeof(description),
    version,    	sizeof(version),
    uri,    		sizeof(uri),
    serial,    		sizeof(serial)
};
/*** ADϊʂ̕ϊpjI ***/
union{
	signed long lData;						// long^
	unsigned char cData[4];					// char^
}DataArray;
float Value;
/** ֐vg^CsO **/
void Process(void);
void CmdI2C(unsigned char data);
void GetDataI2C(unsigned char *Buffer, unsigned char CNT);
void IdleI2C1(void);

/*************@C֐ ******************/
int main(void){
	CLKDIV = 0x0020;							// 96MHz PLL On CPU 32MHz
	/* I/O */
	TRISA = 0x000C;
	TRISB = 0x1F4F;
	AD1PCFG = 0xFFFF;							// ׂăfW^
	// XCb`͗pvAbv
	CNPU1bits.CN5PUE = 1;						// XCb`pvAbv
	CNPU1bits.CN6PUE = 1;
	// I2C̏ݒ
	I2C1BRG = 0x9E;								// 100kHz@16MHz
	I2C1CON = 0x8000;							// I2CCl[u
	CmdI2C(0x8C);								// ŏADϊJn		
	/* USBAPX^[g */
	State = DEVICE_NOT_CONNECTED;				// USBԂɃZbg
	USBInitialize(0);							// USB
	AndroidAppStart(&myDeviceInfo);				// AndroidANZT	

	/************ C[v@****************************/
	while(1)	{
		DWORD size;
		BYTE errorCode, Result;	
				
		/*** USBXe[g֐s ***/
		USBTasks();											// USBMs
		/* f^b`o */
		if(device_attached == FALSE){						// foCXڑH
			LED0_Off();										// ڈLED
			LED1_On();
			State = DEVICE_NOT_CONNECTED;					// Ԃ
		}
		/***** Xe[gɏ]ďs ********/
		switch(State){
			case DEVICE_NOT_CONNECTED:						// foCXڑ
		 		/**** A^b`o  ****/	
				if(device_attached == TRUE){				// A^b`ꂽH
					LED0_On();								// ڈLED
					LED1_Off();
					State = DEVICE_CONNECTED;				// ڑ
				}
				break;				
			case DEVICE_CONNECTED:							// ڑmF
				send_buffer[0] = MESURE;					// dumyM
				State = SEND;								// MXe[g
				break;
			case RECEIVE:									// Android̎Ms@ő64oCgM
				Result = AndroidAppRead(device_handle, (BYTE*)&read_buffer, (DWORD)sizeof(read_buffer));
				if(Result == USB_SUCCESS)
					State = RECEIVE_WAIT;					// M҂
				break;				
			case RECEIVE_WAIT:								// M҂
				if(AndroidAppIsReadComplete(device_handle, &errorCode, &size) == TRUE){
					if(errorCode == USB_SUCCESS)			// 튮H
						Process();							// R}hs㎟̃Xe[g
					else						
						State = RECEIVE;					// ُȂ疳Ď̎M
				}
				break;	
			case SEND:										// Ms@KvoCĝݑM		
				Result = AndroidAppWrite(device_handle,(BYTE*)&send_buffer, count);
				if(Result == USB_SUCCESS)	
					State = SEND_WAIT;						// Ȃ瑗M҂
				else
					State = RECEIVE;						// ̎M
				break;
			case SEND_WAIT:									// M҂
				if(AndroidAppIsWriteComplete(device_handle, &errorCode, &size) == TRUE)
					State = RECEIVE;						// Ŏ̎M
				break;
			default :
				State = DEVICE_NOT_CONNECTED;
				break;			
		}
	}
}

/**********************************************************
* MR}hs֐ 
***********************************************************/
void Process(void){
	int i;
	unsigned char temp[5];									// ϊf[^ꎞi[GA
	
	switch(read_buffer[0]){									// R}h擾
		/* ڑmFv̏ꍇ */		
		case OKCHECK:
			send_buffer[0] = OKCHECK;						// mFH
			send_buffer[1] = 'O';							// OKbZ[Wԑ
			send_buffer[2] = 'K';
			count = 3;										// MoCgZbg
			State = SEND;									// M
			break;
		/* vv̏ꍇ */
		case MESURE:
			LATBbits.LATB4 = !LATBbits.LATB4;				// ڈLED_
			// A/DϊsƐl̕ϊ
			GetDataI2C(temp, 3);							// f[^擾//
			DataArray.lData = 0;							// lGA//
			for(i=0; i<3; i++)								// Mf[^𐔒l֕ϊ//
				DataArray.cData[2-i] = temp[i];
			// ̒l͐̒lɕϊ
			if((DataArray.cData[2] & 0x80)!= 0)				// ̒lH//
			{
				DataArray.cData[3] = 0xFF;					// ŏʃoCg//
				DataArray.lData = ~DataArray.lData + 1; 		// ̒lɕϊ//
				send_buffer[3] = '-';						// }CiXtO
			}
			else
				send_buffer[3] = '+';						// vXtO
			/* Mf[^̃Zbg */
			send_buffer[0] = MESURE;			
			if(SW1 == 0)									// ؂ւXCb`Ԏ擾
				send_buffer[1] = 'V';						// dZbg
			else
				send_buffer[1] = 'I';						// dZbg		
			for(i=0; i<3; i++)								// l̃Zbg@3oCĝ
				send_buffer[i+4] = DataArray.cData[i];
			/* Ms@*/
			count = 7;
			State = SEND;									// M
			/* ̌vJn */
			CmdI2C(0x8C);									// ̕ϊJn//					
			break;
		case DISCONNECT:
			State = DEVICE_NOT_CONNECTED;					// Ԃ	
			break;			
		default :
			break;
	}
}


/***************************************************************
* I2CoXgADCɃRtBM[VM
****************************************************************/
void CmdI2C(unsigned char data)
{
	IdleI2C1();
	I2C1CONbits.SEN = 1;   				// X^[go//
	while(I2C1CONbits.SEN);				// X^[gI҂//
	I2C1TRN = 0xD0;						// AhXM//
	while(I2C1STATbits.TBF);			// MI҂//
	while(I2C1STATbits.ACKSTAT);		// ACKԐM҂//
	IdleI2C1();							// ACh҂//
	I2C1TRN = data;						// RtBM[VM//
	while(I2C1STATbits.TBF);			// MI҂//
	IdleI2C1();							// ACh҂//
	while(I2C1STATbits.ACKSTAT);		// ACKԐM҂//	
	IdleI2C1();							// ACh҂//	
    I2C1CONbits.PEN = 1;   				// Xgbvo//
	while(I2C1CONbits.PEN);				// XgbvI҂//
}
/** ACh҂Tu֐@***/
void IdleI2C1(void)
{
    /* Wait until I2C Bus is Inactive */
    while(I2C1CONbits.SEN || I2C1CONbits.PEN || I2C1CONbits.RCEN
    		 || I2C1CONbits.ACKEN || I2C1STATbits.TRSTAT);  
}
/***************************************************************
* I2CoXgADCϊf[^擾
****************************************************************/
void GetDataI2C(unsigned char *Buffer, unsigned char CNT)
{
	unsigned char i;
	IdleI2C1();							// ACh҂..
    I2C1CONbits.SEN = 1;   				// X^[go//
	while(I2C1CONbits.SEN);				// X^[gI҂
	I2C1TRN = 0xD1;						// AhXM@M[h
	while(I2C1STATbits.TBF);			// M҂//
	while(I2C1STATbits.ACKSTAT);		// ACKM҂//
	IdleI2C1();							// ACh҂//
	for(i=0; i<CNT; i++)				// oCgAM//
	{
    		I2C1CONbits.ACKDT = 0;		// ACKݒ//
 	   	I2C1CONbits.RCEN = 1;			// M//
    		while(I2C1CONbits.RCEN);	// M҂//
    		I2C1CONbits.ACKEN = 1;		// ACKԑ//
		Buffer[i] = I2C1RCV;			// Mf[^擾//
    		I2C1STATbits.I2COV = 0;		// G[NA//
		IdleI2C1();						// ACh҂//
	}
  	I2C1CONbits.ACKDT = 1;				// NACKݒ//
   	I2C1CONbits.RCEN = 1;				// M//
  	while(I2C1CONbits.RCEN);			// M҂//
  	I2C1CONbits.ACKEN = 1;				// NACKԑ//
	Buffer[i] = I2C1RCV;				// Mf[^擾//
  	I2C1STATbits.I2COV = 0;				// G[NA//
	IdleI2C1();							// ACh҂//
	I2C1CONbits.PEN = 1;   				// Xgbvo//
	while(I2C1CONbits.PEN);				// XgbvI҂//
}


/****************************************************************************
*  USBf[^Cxg֐
*    BOOL USB_ApplicationDataEventHandler( BYTE address, USB_EVENT event, void *data, DWORD size )
***************************************************************************/
BOOL USB_ApplicationDataEventHandler( BYTE address, USB_EVENT event, void *data, DWORD size )
{
    return FALSE;
}
/****************************************************************************
*  USBCxg֐Q
*    BOOL USB_ApplicationEventHandler( BYTE address, USB_EVENT event, void *data, DWORD size )
***************************************************************************/
BOOL USB_ApplicationEventHandler( BYTE address, USB_EVENT event, void *data, DWORD size )
{
    switch( event )
    {
        case EVENT_VBUS_REQUEST_POWER:
            // The data pointer points to a byte that represents the amount of power
            // requested in mA, divided by two.  If the device wants too much power,
            // we reject it.
            if (((USB_VBUS_POWER_EVENT_DATA*)data)->current <= (MAX_ALLOWED_CURRENT / 2))
            {
                return TRUE;
            }
             break;

        case EVENT_VBUS_RELEASE_POWER:
        case EVENT_HUB_ATTACH:
        case EVENT_UNSUPPORTED_DEVICE:
        case EVENT_CANNOT_ENUMERATE:
        case EVENT_CLIENT_INIT_ERROR:
        case EVENT_OUT_OF_MEMORY:
        case EVENT_UNSPECIFIED_ERROR:   	// This should never be generated.
        case EVENT_DETACH:                   // USB cable has been detached (data: BYTE, address of device)
        case EVENT_ANDROID_DETACH:
            device_attached = FALSE;
            return TRUE;
            break;

        // Android Specific events
        case EVENT_ANDROID_ATTACH:
            device_attached = TRUE;
            device_handle = data;
            return TRUE;

        default :
            break;
    }
    return FALSE;
}
